// joyinfo.cpp : Defines the entry point for the console application.
//
#ifdef UNICODE
#undef UNICODE
#endif
#ifdef _UNICODE
#undef _UNICODE
#endif
#define STRICT
#define DIRECTINPUT_VERSION 0x0800
#define _CRT_SECURE_NO_DEPRECATE 
#ifndef _WIN32_DCOM
#define _WIN32_DCOM 
#endif
#pragma warning( disable : 4996 ) // disable deprecated warning 

#include <windows.h>
#include <commctrl.h>
#include <basetsd.h>
#include <dinput.h>
#include <assert.h>
#include <oleauto.h>
#include <shellapi.h>

//#include "joyinfo.h"
#include <tchar.h>
#include <strsafe.h>

#define SAFE_RELEASE(p) { if(p) { (p)->Release(); (p)=NULL; } }

LPDIRECTINPUT8       g_pDI              = NULL;
LPDIRECTINPUTDEVICE8 g_pJoystick        = NULL;

TCHAR tszInstanceName[MAX_PATH];
TCHAR tszProductName[MAX_PATH];

HRESULT InitDirectInput( VOID );
VOID FreeDirectInput( VOID );

/* ======================================
typedef struct joyinfoex_tag { 
    DWORD dwSize; 
    DWORD dwFlags; 
    DWORD dwXpos; 
    DWORD dwYpos; 
    DWORD dwZpos; 
    DWORD dwRpos; 
    DWORD dwUpos; 
    DWORD dwVpos; 
    DWORD dwButtons; 
    DWORD dwButtonNumber; 
    DWORD dwPOV; 
    DWORD dwReserved1; 
    DWORD dwReserved2; 
} JOYINFOEX; 

typedef struct { 
    WORD wMid; 
    WORD wPid; 
    TCHAR szPname[MAXPNAMELEN]; 
    UINT wXmin; 
    UINT wXmax; 
    UINT wYmin; 
    UINT wYmax; 
    UINT wZmin; 
    UINT wZmax; 
    UINT wNumButtons; 
    UINT wPeriodMin; 
    UINT wPeriodMax; 
    UINT wRmin; 
    UINT wRmax; 
    UINT wUmin; 
    UINT wUmax; 
    UINT wVmin; 
    UINT wVmax; 
    UINT wCaps; 
    UINT wMaxAxes; 
    UINT wNumAxes; 
    UINT wMaxButtons; 
    TCHAR szRegKey[MAXPNAMELEN]; 
    TCHAR szOEMVxD[MAX_JOYSTICKOEMVXDNAME]; 
} JOYCAPS; 
 
 ========================================== */

MMRESULT last_res = -1;

void out_joy_error( MMRESULT res, UINT u )
{
   switch(res)
   {
   case MMSYSERR_NODRIVER:
      printf( "%d: The joystick driver is not present.\n", u );
      break;
   case MMSYSERR_INVALPARAM:
      printf( "%d: An invalid parameter was passed,\n", u );
      break;
   case MMSYSERR_BADDEVICEID:
      printf( "%d: Windows 95/98/Me: The specified joystick identifier is invalid.\n", u );
      break;
   case JOYERR_UNPLUGGED:
      printf( "%d: The specified joystick is not connected to the system\n", u );
      break;
   case JOYERR_PARMS:
      printf( "%d: Windows NT/2000/XP: The specified joystick identifier is invalid.\n", u );
      break;
   default:
      printf( "%d: Uncased error %d (%x)\n", u, res, res );
      break;
   }
}


int _tmain(int argc, _TCHAR* argv[])
{
   UINT cnt, u;
   JOYINFOEX ji;
   MMRESULT res;
   JOYCAPS jc;

   printf( "Try to obtain joystick information ...\n" );
   cnt = joyGetNumDevs(); 
   printf( "joyGetNumDevs() returned %d count ...\n", cnt );
   for( u = 0; u < cnt; u++ )
   {
      ZeroMemory( &ji, sizeof(JOYINFOEX) );
      ji.dwSize = sizeof(JOYINFOEX);
      res = joyGetPosEx(u, &ji);
      if( res == JOYERR_NOERROR ) {
         short iX, iY, iZ, iR, iU, iV;
         printf( "%d: No error: \n", u );
         iX = (short)ji.dwXpos;
         iY = (short)ji.dwYpos;
         iZ = (short)ji.dwZpos;
         iR = (short)ji.dwRpos;
         iU = (short)ji.dwUpos;
         iV = (short)ji.dwVpos;
         printf( " dwFlags=%x, X=%d, Y=%d, Z=%d, R=%d, U=%d, V=%d\n"
            "dwButtons=%d, dwButtoneNumber=%d, dwPOV=%d\n",
            ji.dwFlags,
            iX, iY, iZ, iR, iU, iV,
            ji.dwButtons,
            ji.dwButtonNumber,
            ji.dwPOV );
         ZeroMemory( &jc, sizeof(JOYCAPS) );
         res = joyGetDevCaps(u,  // UINT_PTR  uJoyID,
            &jc,                 // LPJOYCAPS pjc,
            sizeof(JOYCAPS) );   // UINT      cbjc
         if(res == JOYERR_NOERROR) {
            // TCHAR szRegKey[MAXPNAMELEN];
            // TCHAR szOEMVxD[MAX_JOYSTICKOEMVXDNAME];
            if( jc.szRegKey[0] )
               printf( "szRegKey=[%s]", jc.szRegKey );
            else
               printf( "szRegKey=[<null>]" );
            if( jc.szOEMVxD[0] )
               printf( " szOEMVxD=[%s]", jc.szOEMVxD );
            else
               printf( " szOEMVxD=[<null>]" );
            if( jc.szPname[0] )
               printf( " szPname=[%s]", jc.szPname );
            else
               printf( " szPname=[<null>]" );
            printf("\n");

         } else {
            out_joy_error(res, u);
         }
      } else {
         if( res != last_res ) {
            last_res = res;
            out_joy_error(res, u);
         }
      }
   }

   printf( "\nNow trying the DirectX input interface ...\n" );

   tszInstanceName[0] = 0;
   tszProductName[0]  = 0;
   InitDirectInput();
   FreeDirectInput();
   if( tszProductName[0] )
   {
      printf( "Product Name=[%s] ...\n", tszProductName );
      if( tszInstanceName[0] && strcmp(tszInstanceName, tszProductName) )
         printf( "Instance Name=[%s] ...\n", tszInstanceName );
   } else {
      if( tszInstanceName[0] )
         printf( "Instance Name=[%s] ...\n", tszInstanceName );
      else
         printf( "Oops, failed to get any information ...\n" );
   }

	return 0;
}

//-----------------------------------------------------------------------------
// Name: EnumJoysticksCallback()
// Desc: Called once for each enumerated joystick. If we find one, create a
//       device interface on it so we can play with it.
//-----------------------------------------------------------------------------
BOOL CALLBACK EnumJoysticksCallback( const DIDEVICEINSTANCE* pdidInstance,
                                     VOID* pContext )
{
    UNREFERENCED_PARAMETER( pContext );
    HRESULT hr;

    //if( g_bFilterOutXinputDevices && IsXInputDevice( &pdidInstance->guidProduct ) )
    //    return DIENUM_CONTINUE;

    //pdidInstance->tszProductName
    // Obtain an interface to the enumerated joystick.
    hr = g_pDI->CreateDevice( pdidInstance->guidInstance, &g_pJoystick, NULL );

    // If it failed, then we can't use this joystick. (Maybe the user unplugged
    // it while we were in the middle of enumerating it.)
    if( FAILED(hr) ) 
        return DIENUM_CONTINUE;

   StringCchCopy( tszInstanceName, sizeof(tszInstanceName), pdidInstance->tszInstanceName );
   StringCchCopy( tszProductName,  sizeof(tszProductName),  pdidInstance->tszProductName  );

    // Stop enumeration. Note: we're just taking the first joystick we get. You
    // could store all the enumerated joysticks and let the user pick.
    return DIENUM_STOP;
}


HRESULT InitDirectInput( VOID )
{
    HRESULT hr;

    // Register with the DirectInput subsystem and get a pointer
    // to a IDirectInput interface we can use.
    // Create a DInput object
    if( FAILED( hr = DirectInput8Create( GetModuleHandle(NULL), DIRECTINPUT_VERSION, 
                                         IID_IDirectInput8, (VOID**)&g_pDI, NULL ) ) )
        return hr;


    //if( g_bFilterOutXinputDevices )
    //    SetupForIsXInputDevice();

    // Look for a simple joystick we can use for this sample program.
    if( FAILED( hr = g_pDI->EnumDevices( DI8DEVCLASS_GAMECTRL, 
                                         EnumJoysticksCallback,
                                         NULL, DIEDFL_ATTACHEDONLY ) ) )
        return hr;

    //if( g_bFilterOutXinputDevices )
    //    CleanupForIsXInputDevice();

    // Make sure we got a joystick
    if( NULL == g_pJoystick )
    {
        //MessageBox( NULL, TEXT("Joystick not found. The sample will now exit."),  
        //            TEXT("DirectInput Sample"), 
        //            MB_ICONERROR | MB_OK );
        //EndDialog( hDlg, 0 );
       return S_FALSE;  // failed to get a JOYSTICK
    }
    return S_OK;
}

//-----------------------------------------------------------------------------
// Name: FreeDirectInput()
// Desc: Initialize the DirectInput variables.
//-----------------------------------------------------------------------------
VOID FreeDirectInput()
{
    // Unacquire the device one last time just in case 
    // the app tried to exit while the device is still acquired.
    if( g_pJoystick ) 
        g_pJoystick->Unacquire();
    
    // Release any DirectInput objects.
    SAFE_RELEASE( g_pJoystick );
    SAFE_RELEASE( g_pDI );
}

// eof - joyinfo.cpp

